#include "ToneGen.h"

AToneGenerator::AToneGenerator(float freq, )
{
	fSampleRate = 8000;
	fTwoPiDivSampleRate = (float)(2.0*PI/fSampleRate);
	
	
	fSubscriber = new BAudioSubscriber("audiodevice");

	fSubscriberID = fSubscriber->Subscribe(DAC_STREAM, INVISIBLE_SUBSCRIBER_ID, 1);
	
	fSubscriber->SetSamplingRate(8000);
	fSubscriber->SetDACParameters(2,1,SOUND_FORMAT_BIG_ENDIAN,SOUND_FORMAT_LINEAR);
	
	// Initialize the parameters
	NextSample(freq, rate, -1);
}

void
AToneGenerator::Play(float freq, float duration)
{
}

void
AToneGenerator::NextSample(float freq, float rate, int changed)
{
	float out;
	float wosc;
	
	// If changed == ...
	//	-1 == start new sequence from time 0
	//   0 == no change, generate next sample in sequence
	//   1 == change rate or frequency after start
	
	if (changed != 0)
	{
		wosc = freq * fTwoPiDivSampleRate;
		fArg = 2.0*cos(wosc);
		fA = fArg*rate;
		fB = -rate*rate;
		
		if (changed < 0)	// restart case, set state variables
		{
			fY0 = 0.0f;
			return (fY1 = rate*sin(wosc));
		}
	}
	
	// Now make the new sample
	out = fA * fY1 + fB*fY0;
	fY0 = fY1;
	fY1 = out;
	
	return out;
}
